import { ATN } from "antlr4ts/atn/ATN";
import { FailedPredicateException } from "antlr4ts/FailedPredicateException";
import { Parser } from "antlr4ts/Parser";
import { ParserRuleContext } from "antlr4ts/ParserRuleContext";
import { RuleContext } from "antlr4ts/RuleContext";
import { TerminalNode } from "antlr4ts/tree/TerminalNode";
import { Token } from "antlr4ts/Token";
import { TokenStream } from "antlr4ts/TokenStream";
import { Vocabulary } from "antlr4ts/Vocabulary";
import { CalculatorListener } from "./CalculatorListener";
import { CalculatorVisitor } from "./CalculatorVisitor";
export declare class CalculatorParser extends Parser {
    static readonly T__0 = 1;
    static readonly T__1 = 2;
    static readonly T__2 = 3;
    static readonly T__3 = 4;
    static readonly T__4 = 5;
    static readonly T__5 = 6;
    static readonly T__6 = 7;
    static readonly T__7 = 8;
    static readonly T__8 = 9;
    static readonly T__9 = 10;
    static readonly T__10 = 11;
    static readonly T__11 = 12;
    static readonly T__12 = 13;
    static readonly T__13 = 14;
    static readonly NUMBER = 15;
    static readonly FLOAT = 16;
    static readonly DIGIT = 17;
    static readonly MOD = 18;
    static readonly WHOLE = 19;
    static readonly MUL = 20;
    static readonly DIV = 21;
    static readonly ADD = 22;
    static readonly SUB = 23;
    static readonly PI = 24;
    static readonly EXPONENT = 25;
    static readonly NEGEXPONENT = 26;
    static readonly EULER = 27;
    static readonly SQRT = 28;
    static readonly SQR = 29;
    static readonly FLOOR = 30;
    static readonly CEIL = 31;
    static readonly ABS = 32;
    static readonly ROUNDK = 33;
    static readonly ROUND = 34;
    static readonly TRUNC = 35;
    static readonly SIN = 36;
    static readonly COS = 37;
    static readonly TAN = 38;
    static readonly COT = 39;
    static readonly SINH = 40;
    static readonly COSH = 41;
    static readonly TANH = 42;
    static readonly ARCSIN = 43;
    static readonly ARCCOS = 44;
    static readonly ARCTAN = 45;
    static readonly ARCTAN2 = 46;
    static readonly ARCCOT = 47;
    static readonly EXP = 48;
    static readonly LN = 49;
    static readonly EEX = 50;
    static readonly LOG = 51;
    static readonly RAD = 52;
    static readonly DEG = 53;
    static readonly MIN = 54;
    static readonly MAX = 55;
    static readonly WS = 56;
    static readonly COM = 57;
    static readonly SUBSTITUTION = 58;
    static readonly SEMICOLON = 59;
    static readonly INVALID = 60;
    static readonly RULE_calculator = 0;
    static readonly RULE_expression = 1;
    static readonly RULE_trailingComment = 2;
    static readonly RULE_compileUnit = 3;
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    get vocabulary(): Vocabulary;
    get grammarFileName(): string;
    get ruleNames(): string[];
    get serializedATN(): string;
    protected createFailedPredicateException(predicate?: string, message?: string): FailedPredicateException;
    constructor(input: TokenStream);
    calculator(): CalculatorContext;
    expression(): ExpressionContext;
    expression(_p: number): ExpressionContext;
    trailingComment(): TrailingCommentContext;
    compileUnit(): CompileUnitContext;
    sempred(_localctx: RuleContext, ruleIndex: number, predIndex: number): boolean;
    private expression_sempred;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static get _ATN(): ATN;
}
export declare class CalculatorContext extends ParserRuleContext {
    expression(): ExpressionContext;
    compileUnit(): CompileUnitContext;
    trailingComment(): TrailingCommentContext | undefined;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ExpressionContext extends ParserRuleContext {
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: ExpressionContext): void;
}
export declare class UnaryContext extends ExpressionContext {
    SUB(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class UnaryPlusContext extends ExpressionContext {
    ADD(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class FloorContext extends ExpressionContext {
    FLOOR(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class CeilContext extends ExpressionContext {
    CEIL(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class AbsContext extends ExpressionContext {
    ABS(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class RoundkContext extends ExpressionContext {
    ROUNDK(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    SEMICOLON(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class RoundContext extends ExpressionContext {
    ROUND(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class TruncContext extends ExpressionContext {
    TRUNC(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class SinContext extends ExpressionContext {
    SIN(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class CosContext extends ExpressionContext {
    COS(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class TanContext extends ExpressionContext {
    TAN(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class CotContext extends ExpressionContext {
    COT(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class SinhContext extends ExpressionContext {
    SINH(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class CoshContext extends ExpressionContext {
    COSH(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class TanhContext extends ExpressionContext {
    TANH(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ArcsinContext extends ExpressionContext {
    ARCSIN(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ArccosContext extends ExpressionContext {
    ARCCOS(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ArctanContext extends ExpressionContext {
    ARCTAN(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class Arctan2Context extends ExpressionContext {
    ARCTAN2(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    SEMICOLON(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ArccotContext extends ExpressionContext {
    ARCCOT(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ExpContext extends ExpressionContext {
    EXP(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class LnContext extends ExpressionContext {
    LN(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class EexContext extends ExpressionContext {
    EEX(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class LogContext extends ExpressionContext {
    LOG(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class RadContext extends ExpressionContext {
    RAD(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class DegContext extends ExpressionContext {
    DEG(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class SqrtContext extends ExpressionContext {
    SQRT(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class SqrContext extends ExpressionContext {
    SQR(): TerminalNode;
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ExponentContext extends ExpressionContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    EXPONENT(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class NegExponentContext extends ExpressionContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    NEGEXPONENT(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class PowContext extends ExpressionContext {
    _op: Token;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ModContext extends ExpressionContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    MOD(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class WholeContext extends ExpressionContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    WHOLE(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class SqRootContext extends ExpressionContext {
    _op: Token;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class MulDivContext extends ExpressionContext {
    _op: Token;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    MUL(): TerminalNode | undefined;
    DIV(): TerminalNode | undefined;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class ParenthesisContext extends ExpressionContext {
    expression(): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class MultContext extends ExpressionContext {
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class MinContext extends ExpressionContext {
    _expression: ExpressionContext;
    _expr: ExpressionContext[];
    MIN(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    SEMICOLON(): TerminalNode[];
    SEMICOLON(i: number): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class MaxContext extends ExpressionContext {
    _expression: ExpressionContext;
    _expr: ExpressionContext[];
    MAX(): TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    SEMICOLON(): TerminalNode[];
    SEMICOLON(i: number): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class AddSubContext extends ExpressionContext {
    _op: Token;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext;
    ADD(): TerminalNode | undefined;
    SUB(): TerminalNode | undefined;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class NumberContext extends ExpressionContext {
    NUMBER(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class PiContext extends ExpressionContext {
    PI(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class EulerContext extends ExpressionContext {
    EULER(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class RangeContext extends ExpressionContext {
    _start: Token;
    _end: Token;
    SUBSTITUTION(): TerminalNode[];
    SUBSTITUTION(i: number): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class SubstitutionContext extends ExpressionContext {
    SUBSTITUTION(): TerminalNode;
    constructor(ctx: ExpressionContext);
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class TrailingCommentContext extends ParserRuleContext {
    SEMICOLON(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
export declare class CompileUnitContext extends ParserRuleContext {
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext | undefined, invokingState: number);
    get ruleIndex(): number;
    enterRule(listener: CalculatorListener): void;
    exitRule(listener: CalculatorListener): void;
    accept<Result>(visitor: CalculatorVisitor<Result>): Result;
}
